/*
 File: rtn_component.h
 Date and Time: Fri Jan 30 18:55:22 2015 
*/
#ifndef __rtn_component_h__
#define __rtn_component_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "identifier.h"
#include "c_string.h"
#include "unq_str.h"
#include "yacco2_stbl.h"
  
extern yacco2::Thread_entry ITH_rtn_component;

extern yacco2::State S1_Crtn_component;
namespace NS_rtn_component {
yacco2::THR _YACCO2_CALL_TYPE
TH_rtn_component(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_rtn_component(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[1];
};
class Crtn_component: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rrtn_component_ = 569//start_of_rule_list + 0
    ,rhs1_Rrtn_component_ = 1
    ,rhs2_Rrtn_component_ = 2
    ,rhs3_Rrtn_component_ = 3
    ,rhs4_Rrtn_component_ = 4
    ,rhs5_Rrtn_component_ = 5
    ,rhs6_Rrtn_component_ = 6
    ,rhs7_Rrtn_component_ = 7
  };
  //no of la sets = 1
  //no of states = 9
  Crtn_component();
  ~Crtn_component();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[8];
  
    public:
      void fnd_T_of_chr_str(const char* Str,yacco2::CAbs_lr1_sym* Tok);
  
 };
struct Rrtn_component;
yacco2::THR _YACCO2_CALL_TYPE
AR_Rrtn_component(yacco2::Parser* Caller_pp);// rule's arbitrator
struct Rrtn_component:public yacco2::CAbs_lr1_sym {
  Rrtn_component(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
};

} // end of namespace

#endif
